## dynmhs-0.2.4.tar.xz

=== CMakeLists.txt ===
# ===========================================================================
#                    ____              __  __ _   _ ____
#                   |  _ \ _   _ _ __ |  \/  | | | / ___|
#                   | | | | | | | '_ \| |\/| | |_| \___ \
#                   | |_| | |_| | | | | |  | |  _  |___) |
#                   |____/ \__, |_| |_|_|  |_|_| |_|____/
#                          |___/
#
#                ---  Dynamic Multi-Homing Setup (DynMHS)  ---
#                     https://www.nntb.no/~dreibh/dynmhs/
# ===========================================================================
#
# Dynamic Multi-Homing Setup (DynMHS)
# Copyright (C) 2024-2025 by Thomas Dreibholz
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Contact: dreibh@simula.no

CMAKE_MINIMUM_REQUIRED(VERSION 3.10)
PROJECT(dynmhs LANGUAGES C CXX)

SET(BUILD_MAJOR "0")
SET(BUILD_MINOR "2")
SET(BUILD_PATCH "4")
SET(BUILD_VERSION ${BUILD_MAJOR}.${BUILD_MINOR}.${BUILD_PATCH})

# HiPerConTracer needs at least C++17!
SET(CMAKE_CXX_STANDARD 17)


#############################################################################
#### INSTALLATION_DIRECTORIES                                            ####
#############################################################################

# See: https://cmake.org/cmake/help/v3.0/module/GNUInstallDirs.html
INCLUDE(GNUInstallDirs)


#############################################################################
#### PACKAGING                                                           ####
#############################################################################

SET(CPACK_SOURCE_GENERATOR "TXZ")
SET(CPACK_SOURCE_PACKAGE_FILE_NAME
    "${CMAKE_PROJECT_NAME}-${BUILD_MAJOR}.${BUILD_MINOR}.${BUILD_PATCH}")
SET(CPACK_SOURCE_IGNORE_FILES "\\\\.git;\\\\.swp$;~$;\\\\.\\\\#;/\\\\#")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "^${PROJECT_SOURCE_DIR}/${CMAKE_PROJECT_NAME}[_-]")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "\\\\.cmake$|\\\\.make$|\\\\.log$")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "/CMakeCache\\\\.txt$")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "/(CMakeFiles|CMakeScripts|_CPack_Packages)/")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "/package-version\\\\.h$")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "/packaging\\\\.conf$")
LIST(APPEND CPACK_SOURCE_IGNORE_FILES "^${PROJECT_SOURCE_DIR}/(po.*/|src.*/|)Makefile$")
INCLUDE(CPack)

ADD_CUSTOM_TARGET(dist COMMAND ${CMAKE_MAKE_PROGRAM} clean package_source)


#############################################################################
#### UNINSTALL                                                           ####
#############################################################################

IF(NOT TARGET uninstall)
   CONFIGURE_FILE(
      "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
      "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
      IMMEDIATE @ONLY)

   ADD_CUSTOM_TARGET(uninstall
      COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
ENDIF()


#############################################################################
#### OS DEPENDENT                                                        ####
#############################################################################

IF (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")

ELSEIF (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
    SET(CMAKE_REQUIRED_INCLUDES "/usr/local/include" "/usr/include")
    SET(CMAKE_LIBRARY_PATH "/usr/local/lib" "/usr/local/lib/mariadb")
    INCLUDE_DIRECTORIES("/usr/local/include")

ELSEIF (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
    SET(CMAKE_REQUIRED_INCLUDES "/usr/local/include" "/usr/include" "/usr/local/opt/openssl/include")
    SET(CMAKE_LIBRARY_PATH "/usr/local/lib")
    INCLUDE_DIRECTORIES("/usr/local/include" "/usr/local/opt/openssl/include")

ELSEIF (${CMAKE_SYSTEM_NAME} MATCHES "NetBSD")
    MESSAGE(STATUS ${CMAKE_SYSTEM_NAME} " supported")
    SET(CMAKE_REQUIRED_INCLUDES "/usr/pkg/include" "/usr/include" "/usr/local/include")
    SET(CMAKE_LIBRARY_PATH "/usr/local/lib")
    INCLUDE_DIRECTORIES("/usr/pkg/include" "/usr/local/include")

ELSE()
    MESSAGE(FATAL_ERROR ${CMAKE_SYSTEM_NAME} " not supported (yet?)")

ENDIF()


#############################################################################
#### REQUIREMENTS                                                        ####
#############################################################################

# ====== Boost ==============================================================
IF(CMAKE_VERSION VERSION_GREATER_EQUAL "3.30")
   # Use BoostConfig.cmake to find BOOST libraries, if possible.
   CMAKE_POLICY(SET CMP0167 NEW)
ENDIF()
FIND_PACKAGE(Boost REQUIRED COMPONENTS log program_options)
IF (NOT Boost_FOUND)
   MESSAGE(FATAL_ERROR "Cannot find Boost libraries!")
ELSE()
  INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})
ENDIF()
IF (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
   ADD_DEFINITIONS(-DBOOST_ALL_DYN_LINK)   # <<-- Required to handle BOOST Log link problem!
ENDIF()


#############################################################################
#### SUBDIRECTORIES                                                      ####
#############################################################################

ADD_SUBDIRECTORY(src)

=== src/CMakeLists.txt ===
# ===========================================================================
#                    ____              __  __ _   _ ____
#                   |  _ \ _   _ _ __ |  \/  | | | / ___|
#                   | | | | | | | '_ \| |\/| | |_| \___ \
#                   | |_| | |_| | | | | |  | |  _  |___) |
#                   |____/ \__, |_| |_|_|  |_|_| |_|____/
#                          |___/
#
#                ---  Dynamic Multi-Homing Setup (DynMHS)  ---
#                     https://www.nntb.no/~dreibh/dynmhs/
# ===========================================================================
#
# Dynamic Multi-Homing Setup (DynMHS)
# Copyright (C) 2024-2025 by Thomas Dreibholz
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Contact: dreibh@simula.no

#############################################################################
#### VERSION FILE                                                        ####
#############################################################################

CONFIGURE_FILE (
   "${CMAKE_CURRENT_SOURCE_DIR}/package-version.h.in"
   "${CMAKE_CURRENT_BINARY_DIR}/package-version.h"
)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})


#############################################################################
#### PROGRAMS                                                            ####
#############################################################################

ADD_EXECUTABLE(dynmhs dynmhs.cc
   assure.cc
   logger.cc
)
TARGET_LINK_LIBRARIES(dynmhs ${Boost_LIBRARIES})
INSTALL(TARGETS dynmhs         RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
INSTALL(FILES   dynmhs.1       DESTINATION         ${CMAKE_INSTALL_MANDIR}/man1)
INSTALL(FILES   dynmhs.service DESTINATION         ${CMAKE_INSTALL_PREFIX}/lib/systemd/system)
INSTALL(FILES   dynmhs.conf    DESTINATION         /etc/dynmhs)
INSTALL(FILES   dynmhs.bash-completion
        DESTINATION ${CMAKE_INSTALL_DATADIR}/bash-completion/completions
        RENAME      dynmhs)

=== debian/changelog ===
dynmhs (0.2.4-1ubuntu1) trixie; urgency=medium

  * New upstream release.
  * Closes: #1099114 (ITP).

 -- Thomas Dreibholz <dreibh@simula.no>  Fri, 24 Oct 2025 13:29:41 +0200

dynmhs (0.2.3-1ubuntu1) trixie; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@simula.no>  Sun, 21 Sep 2025 19:19:55 +0200

dynmhs (0.2.2-1ubuntu1) trixie; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@simula.no>  Sat, 17 May 2025 22:04:17 -0400

dynmhs (0.2.1-1ubuntu1) trixie; urgency=medium

  * New upstream release.
  * debian/control: Updated standards version to 4.7.2.

 -- Thomas Dreibholz <dreibh@simula.no>  Mon, 12 May 2025 22:50:52 +0200

dynmhs (0.2.0-1ubuntu1) trixie; urgency=medium

  * New upstream release.
  * debian/control: Updated standards version to 4.7.0.

 -- Thomas Dreibholz <dreibh@simula.no>  Fri, 28 Feb 2025 15:57:28 +0100

dynmhs (0.1.0-1ubuntu1) trixie; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@simula.no>  Fri, 13 Dec 2024 21:34:09 +0100

dynmhs (0.0.0-1ubuntu1) noble; urgency=medium

  * New upstream release.

 -- Thomas Dreibholz <dreibh@simula.no>  Wed, 13 Nov 2024 21:54:44 +0100

=== debian/control ===
Source: dynmhs
Section: net
Priority: optional
Maintainer: Thomas Dreibholz <dreibh@simula.no>
Homepage: https://www.nntb.no/~dreibh/dynmhs/
Vcs-Git: https://github.com/simula/dynmhs.git
Vcs-Browser: https://github.com/simula/dynmhs
Build-Depends: cmake,
               debhelper (>= 12),
               libboost-log-dev,
               libboost-program-options-dev
Standards-Version: 4.7.2
Rules-Requires-Root: no

Package: dynmhs
Architecture: any
Depends: iproute2,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: hipercontracer,
            netperfmeter,
            subnetcalc
Suggests: iputils-tracepath,
          ping | iputils-ping,
          td-system-tools,
          traceroute | inetutils-traceroute,
          tsctp
Description: Dynamic Multi-Homing Setup (DynMHS)
 DynMHS dynamically sets up IP routing rules, to allow using multiple
 network connections simultaneously. That is, for each relevant network
 interface, a separate routing table is created and maintained. For each
 source address of a network interface managed by DynMHS, routing rules
 are maintained to point to the corresponding routing table. Software
 binding to a specific interface address can then use a specific
 network. In addition, multi-homing-capable network protocols like the
 Multi-Path TCP (MPTCP) or the Stream Control Transmission Protocol (SCTP)
 can take advantage of multi-homing for redundancy and load balancing.

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ \
https://www.nntb.no/~dreibh/dynmhs/index.html    download/dynmhs-(.*)\.tar\.xz
